<?xml version="1.0" encoding="utf-8" standalone="no"?>

<!DOCTYPE book PUBLIC "-//OASIS//DTD DocBook XML V4.4//EN"
                      "http://docbook.org/xml/4.4/docbookx.dtd">

<book id="tools_and_apps">
  <title>Installing and Configuring Some Advanced Internet Services, Network Tools and Web Applications</title>
  <bookinfo>
    <legalnotice>
      <para>Copyright (C) 2004 Dashamir Hoxha, Neki Frasheri. Permission is granted to copy, distribute and/or modify this document under the terms of the GNU Free Documentation License, Version 1.1 or any later version published by the Free Software Foundation; with the Invariant Sections being LIST THEIR TITLES, with the Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST. A copy of the license is included in the section entitled "GNU Free Documentation License."</para>
    </legalnotice>
    <author>
      <firstname>Dashamir</firstname>
      <surname>Hoxha</surname>
      <affiliation>
        <orgname>
          <ulink url="http://www.inima.al">INIMA</ulink>
        </orgname>
        <address>
          <email>dhoxha@inima.al</email>
        </address>
      </affiliation>
    </author>
    <author>
      <firstname>Neki</firstname>
      <surname>Frasheri</surname>
      <affiliation>
        <orgname>
          <ulink url="http://www.inima.al">INIMA</ulink>
        </orgname>
        <address>
          <email>nfra@inima.al</email>
        </address>
      </affiliation>
    </author>
    <date>04/05/2004</date>
    <releaseinfo>0.1</releaseinfo>
    <abstract>
      <para>This reference documents the work that is done in the server of INIMA for installing and configuring some advanced internet services, network monitoring tools, usefull web applications etc. It may also be useful for any linux admin that wants to install such tools. The reference will take an "hands on" (practical) aproach with step-by-step instructions for each tool or application that is installed.</para>
    </abstract>
    <keywordset>
      <keyword>GNU/Linux</keyword>
      <keyword>Red Hat 9</keyword>
      <keyword>server</keyword>
      <keyword>administrator</keyword>
      <keyword>internet services</keyword>
      <keyword>network tools</keyword>
      <keyword>web applications</keyword>
    </keywordset>
  </bookinfo>
  <chapter id="introduction">
    <title>Introduction</title>
    <section id="about">
      <title>About this guide</title>
    </section>
    <section id="audience">
      <title>Who should read this guide</title>
    </section>
    <section id="situation">
      <title>Description of the situation</title>
    </section>
    <section id="requirements">
      <title>Requirements</title>
    </section>
  </chapter>
  <chapter id="communication">
    <title>Communication Services</title>
    <para/>
    <section id="exim">
      <title>Exim - Mail Service</title>
      <para/>
      <section id="compilation">
        <title>Getting and Compiling Exim</title>
        <orderedlist continuation="restarts" inheritnum="ignore">
          <listitem>
            <para>Get the latest version of exim from <ulink url="http://www.exim.org/mirrors.html"/> , e.g.:
<screen>
<prompt>bash$</prompt> <command>wget ftp://ftp.csx.cam.ac.uk/pub/software/email/exim/exim4/exim-4.42.tar.gz .</command>
</screen>
Get also the latest docs, e.g.:
<screen>
<prompt>bash$</prompt> <command>wget ftp://ftp.csx.cam.ac.uk/pub/software/email/exim/exim4/exim-html-4.30.tar.gz .</command>
<prompt>bash$</prompt> <command>wget ftp://ftp.csx.cam.ac.uk/pub/software/email/exim/exim4/exim-html-4.30.tar.gz .</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Extract it in <filename>/usr/local/src/</filename> :
<screen>
<prompt>bash#</prompt> <command>mv exim-*.tar.gz /usr/local/src/tgz/</command>
<prompt>bash#</prompt> <command>cd /usr/local/src/</command>
<prompt>bash#</prompt> <command>tar xfz tgz/exim-4.42.tar.gz</command>
<prompt>bash#</prompt> <command>cd exim-4.42/</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Create <filename>Local/Makefile</filename> :
<screen>
<prompt>bash#</prompt> <command>cp src/EDITME Local/Makefile</command>
<prompt>bash#</prompt> <command>vi Local/Makefile</command>
</screen><programlisting>
BIN_DIRECTORY=/usr/local/exim/bin
CONFIGURE_FILE=/usr/local/exim/exim.conf
EXIM_USER=ref:mail
SPOOL_DIRECTORY=/var/spool/exim
SUPPORT_MAILDIR=yes
# EXIM_MONITOR=eximon.bin
LOG_FILE_PATH=/var/log/exim_%s.log
USE_TCP_WRAPPERS=yes
EXTRALIBS_EXIM=-lwrap -ldl
</programlisting></para>
          </listitem>
          <listitem>
            <para>Make sure that <emphasis>db4</emphasis> and <emphasis>db4-devel</emphasis> packages are installed and install them if they aren't:
<screen>
<prompt>bash$</prompt> <command>rpm -q db4</command>
<prompt>bash$</prompt> <command>rpm -q db4-devel</command>
<prompt>bash#</prompt> <command>rpm -Uhv db4-....rpm</command>
<prompt>bash#</prompt> <command>rpm -Uhv db4-devel-....rpm</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Compile and install:
<screen>
<prompt>bash$</prompt> <command>make</command>
<prompt>bash#</prompt> <command>make install</command>
</screen></para>
          </listitem>
        </orderedlist>
      </section>
      <section id="configuration">
        <title>Exim Configuration</title>
        <para>Edit the configuration file <filename>/usr/local/exim/exim.conf</filename> :
<screen>
<prompt>bash#</prompt> <command>vi /usr/local/exim/exim.conf</command>
</screen>
and make the modifications described in the following sections.</para>
        <itemizedlist/>
        <section id="main_cfg">
          <title>Main (General) Configurations</title>
          <para>Modify these parameters at <filename>/usr/local/exim/exim.conf</filename> at the MAIN CONFIGURATION SETTINGS section:
<programlisting>
primary_hostname = dns3.inima.al
domainlist local_domains = dns3.inima.al : proxy1.inima.al
domainlist relay_to_domains = inima.al : *.inima.al : akad.edu.al : ert.gov.al : cstid.edu.al
hostlist   relay_from_hosts = 127.0.0.1 : 192.168.240.0/20 : 193.254.1.0/24
</programlisting><emphasis>relay_to_domains</emphasis> are the domains for which exim accepts email and <emphasis>relay_from_hosts</emphasis> are the hosts/networks which can send email using exim.</para>
          <para>Add these general parameters before the ACL CONFIGURATION section:
<programlisting>
# Who to send a mail to when a message is frozen
freeze_tell = postmaster

# Time before a queue runner will try a new delivery attempt
# on any frozen message. Default is 0s
auto_thaw = 2d

# Max number of simultaneous SMTP calls to accept
# (aka max number of exim processes) Default is 20
smtp_accept_max = 10

# Max number of waiting SMTP connections.
# Gives some protection against denial-of-service attacks by SYN flooding
# Default is 20
smtp_connect_backlog = 10

# Max number of MAIL commands that Exim is prepared to accept over a
# single SMTP connection, after which a 421 is given. Default is 1000
smtp_accept_max_per_connection = 50

# Max message size to accept
# Default is 50M
message_size_limit = 20M

# Max bounce message size to send
# Default is 100K
return_size_limit = 10K
# Alternative to return_size_limit is to set
#bounce_return_message = false

# Redundant pairs of angle brackets around addresses are removed
# Default is false
strip_excess_angle_brackets = true

# Ignore a trailing dot at the end of a domain in an address
# Default is false
strip_trailing_dot = true
</programlisting></para>
        </section>
        <section id="filter_cfg">
          <title>Filter Configuration</title>
          <orderedlist continuation="restarts" inheritnum="ignore">
            <listitem>
              <para>Add these parameters at <filename>/usr/local/exim/exim.conf</filename> , before the ACL CONFIGURATION section:
<programlisting>
# specify the system filter file
system_filter = /usr/local/exim/exim.filter
system_filter_user = mail
system_filter_group = mail
</programlisting></para>
            </listitem>
            <listitem>
              <para>Create the system filter file <filename>/usr/local/exim/exim.filter</filename> with this content:
<programlisting>
# Exim filter  -- do not remove it, it is required, it is not a comment
                                                                                
### throw away junk or bulk
if
  $h_precedence: is "junk" or
  $h_precedence: is "bulk"
then
  seen finish
endif
                                                                                
### forward mrtg errors to dhoxha, nfra, agor and nresulaj
if
  $h_from: contains "root@" and
  $h_subject: contains "/usr/bin/mrtg"
then
  deliver nfra@inima.al
  deliver dhoxha@inima.al
endif
                                                                                
if
  $h_from: contains "MAILER-DAEMON@hpe25.inima.al"
then
  deliver nfra@inima.al
endif
</programlisting></para>
            </listitem>
            <listitem>
              <para>Create a test message, like this:
<programlisting>
From root@localhost Sat Mar 27 18:31:31 2004
Date: Thu, 29 Apr 2004 10:50:29 +0200
To: postmaster
From: MAILER-DAEMON@hpe25.inima.al
Subject: test

test message

</programlisting>
and test the system filter file:
<screen>
<prompt>bash$</prompt> <command>bin/exim -bF exim.filter &amp;lt; test.msg</command>
<prompt>bash$</prompt> <command>bin/exim -v -bF exim.filter $amp;lt; test.msg</command>
</screen></para>
            </listitem>
            <listitem>
              <para>Restart exim:
<screen>
<prompt>bash#</prompt> <command>/sbin/service exim restart</command>
</screen></para>
            </listitem>
          </orderedlist>
        </section>
        <section id="acl_cfg">
          <title>ACL Configuration</title>
          <para>These access rules provide some protection against spam and void messages, (e.g. messages sent to a user that does not exist at inima.al).</para>
          <para>Add these rules after <emphasis>require verify = sender</emphasis> :
<programlisting>
  # Do not accept HELO/EHLO from hosts using our IP(s) in HELO
  # Could exclude internal IPs, but they should never HELO with our inet IP
  # Remember to update file if IP(s) change!
  deny message     = Forged IP in HELO.
       log_message = HELO is our IP
       condition   = ${lookup {$sender_helo_name} \
                     lsearch{/usr/local/exim/our_inet_ips.txt} \
                     {yes}{no}}

  # Deny unless the sender address can be verified.
  deny    message = From email address must be valid
          # do not check address for lists or bounces
          # or people in our company contact database
          #senders = ^.*-request@.*
          # do not check for DSN-ignorant domains
          # iow those that don't accept MAIL FROM:&lt;&gt;
          !verify  = sender/defer_ok

  # deny if the domain is inima.al but the local_part is not in the
  # list of users (users.inima.al)
  deny domains = inima.al
       local_parts = !lsearch;/usr/local/exim/users.inima.al
</programlisting></para>
          <para>Create the file <filename>/usr/local/exim/our_inet_ips.txt</filename> with all the IP numbers of the server:
<programlisting>
80.78.70.178
193.254.1.195
192.168.251.195
</programlisting></para>
          <para>Create the file <filename>/usr/local/exim/users.inima.al</filename> with all the users of the domain inima.al (users of the server hpe25.inima.al):
<programlisting>
nfra
gbeq
dhoxha
agor
enal
...
</programlisting></para>
        </section>
        <section id="routers_cfg">
          <title>Routers Configuration</title>
          <para>In the ROUTERS CONFIGURATION section add these routers at the beginning, after <emphasis>begin routers</emphasis> :
<programlisting>
# This router forwards all the emails for the domain inima.al
# to the server hpe25.inima.al (without any DNS lookup, MX records etc.)
special:
  driver = manualroute
  transport = remote_smtp
  route_list = inima.al hpe25.inima.al

### N.Frasheri 24 aug 2004 test smarthost
### fail: "cannot find router driver "domainlist"
#smarthost:
#   driver = domainlist
#   transport = remote_smtp
#   route_list = "* 193.254.1.197 bydns_a"
###   route_list = "* mail.example.com bydns_a"
</programlisting></para>
          <para>Also uncomment <emphasis>allow filter</emphasis> at <emphasis>userforward:</emphasis> router.
<programlisting>
userforward:
  driver = redirect
  check_local_user
# local_part_suffix = +* : -*
# local_part_suffix_optional
  file = $home/.forward
  allow_filter
  no_verify
  no_expn
  check_ancestor
  file_transport = address_file
  pipe_transport = address_pipe
  reply_transport = address_reply
</programlisting></para>
        </section>
        <section id="transports_cfg">
          <title>Transports Configuration</title>
          <para>At the TRANSPORTS CONFIGURATION section add these transports:
<programlisting>
# NFrasheri: SMTP transport
                                                                                
smtp:
  driver = smtp
  delay_after_cutoff = false

local_delivery:
  driver = appendfile
  file = /var/mail/$local_part
  delivery_date_add
  envelope_to_add
  return_path_add
  group = mail       # uncomment these two lines
  mode = 0660
</programlisting></para>
        </section>
        <section id="retry_cfg">
          <title>Retry Configuration</title>
          <para>At the RETRY CONFIGURATION section modify this line:
<programlisting>
#*                      *           F,2h,15m; G,16h,1h,1.5; F,4d,6h
*                      *           F,2h,15m; G,6h,1h,1.5; F,4d,6h
</programlisting></para>
        </section>
      </section>
      <section id="installation">
        <title>Installing Exim as an Alternative to Sendmail</title>
        <orderedlist continuation="restarts" inheritnum="ignore">
          <listitem>
            <para>Create the log files:
<screen>
<prompt>bash#</prompt> <command>touch /var/log/exim_main.log</command>
<prompt>bash#</prompt> <command>touch /var/log/exim_panic.log</command>
<prompt>bash#</prompt> <command>touch /var/log/exim_reject.log</command>
<prompt>bash#</prompt> <command>chown mail.mail /var/log/exim_*</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Tell <emphasis>tcpwrappers</emphasis> to allow the port <emphasis>exim</emphasis> for any host:
<screen><prompt>bash#</prompt> <command>vi /etc/hosts.allow</command></screen><programlisting>exim : ALL</programlisting></para>
          </listitem>
          <listitem>
            <para>Create the script <filename>/etc/init.d/exim</filename> (<xref linkend="etc_initd_exim"/>) and add exim in the list of services:
<screen>
<prompt>bash#</prompt> <command>vi /etc/init.d/exim</command>
<prompt>bash#</prompt> <command>chmod 755 /etc/init.d/exim</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --add exim</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --list exim</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Create and run the script <filename>install-exim-alternative.sh</filename> (<xref linkend="install_exim_alternative"/>):
<screen>
<prompt>bash#</prompt> <command>mkdir /usr/local/exim/scripts</command>
<prompt>bash#</prompt> <command>cd /usr/local/exim/scripts</command>
<prompt>bash#</prompt> <command>vi install-exim-alternative.sh</command>
<prompt>bash#</prompt> <command>chmod 755 install-exim-alternative.sh</command>
<prompt>bash#</prompt> <command>./install-exim-alternative.sh</command>
<prompt>bash#</prompt> <command>/usr/sbin/alternatives --display mta</command>
<prompt>bash#</prompt> <command>/usr/sbin/alternatives --auto mta</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Stop sendmail, set exim as MTA and start exim:
<screen>
<prompt>bash#</prompt> <command>/sbin/service sendmail stop</command>
<prompt>bash#</prompt> <command>/usr/sbin/alternatives --set mta /usr/local/exim/bin/exim</command>
<prompt>bash#</prompt> <command>/sbin/service exim start</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --level 2345 sendmail off</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --level 2345 exim on</command>
</screen></para>
          </listitem>
          <listitem>
            <para>In order to go back to sendmail (in case of problems), run these commands:
<screen>
<prompt>bash#</prompt> <command>/sbin/service exim stop</command>
<prompt>bash#</prompt> <command>/usr/sbin/alternatives --set mta /usr/sbin/sendmail.sendmail</command>
<prompt>bash#</prompt> <command>/sbin/service sendmail start</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --level 2345 exim off</command>
<prompt>bash#</prompt> <command>/sbin/chkconfig --level 2345 sendmail on</command>
</screen></para>
          </listitem>
          <listitem>
            <para>The switch between exim and sendmail is done more easily and more reliably using the script <filename>set-mta.sh</filename> :
<screen>
<prompt>bash#</prompt> <command>vi set-mta.sh</command>
<prompt>bash#</prompt> <command>chmod 755 set-mta.sh</command>
<prompt>bash#</prompt> <command>./set-mta.sh</command>
<prompt>bash#</prompt> <command>./set-mta.sh exim</command>
<prompt>bash#</prompt> <command>./set-mta.sh sendmail</command>
</screen></para>
          </listitem>
        </orderedlist>
        <simplesect id="etc_initd_exim">
          <title>/etc/init.d/exim</title>
          <programlisting>
#!/bin/bash
#
# exim    This shell script takes care of starting and stopping exim
#
# chkconfig: 2345 80 30
# description: Exim is a Mail Transport Agent, which is the program \
#              that moves mail from one machine to another.
# processname: exim
# config: /usr/local/exim/exim.conf
# pidfile: /var/run/exim.pid

# Source function library.
. /etc/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Source exim configuration.
if [ -f /etc/sysconfig/exim ] ; then
        . /etc/sysconfig/exim
else
        DAEMON=yes
        QUEUE=1h
fi

# Check that networking is up.
[ ${NETWORKING} = "no" ] &amp;&amp; exit 0

EXIM=/usr/local/exim/bin/exim
[ -f $EXIM ] || exit 0

start() {
        # Start daemons.
        echo -n $"Starting $0: "
        daemon $EXIM $([ "$DAEMON" = yes ] &amp;&amp; echo -bd) \
                              $([ -n "$QUEUE" ] &amp;&amp; echo -q$QUEUE)
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] &amp;&amp; touch /var/lock/subsys/exim
}

stop() {
        # Stop daemons.
        echo -n $"Shutting down $0: "
        killproc exim
        RETVAL=$?
        echo
        [ $RETVAL = 0 ] &amp;&amp; rm -f /var/lock/subsys/exim
}

restart() {
        stop
        start
}

# See how we were called.
case "$1" in
  start)
        start
        ;;
  stop)
        stop
        ;;
  restart)
        restart
        ;;
  reload)
        restart
        ;;
  condrestart)
        [ -f /var/lock/subsys/exim ] &amp;&amp; {
                stop
                [ -x /bin/chown ] &amp;&amp; /bin/chown mail.mail -R /var/spool/exim
                start
        } || {
                [ -x /bin/chown ] &amp;&amp; /bin/chown mail.mail -R /var/spool/exim
        }
        ;;
  status)
        status exim
        ;;
  *)
        echo $"Usage: $0 {start|stop|restart|reload|status|condrestart}"
        exit 1
esac

exit $RETVAL
</programlisting>
        </simplesect>
        <simplesect id="install_exim_alternative">
          <title>install-exim-alternative.sh</title>
          <para>This script installs exim as another alternative to sendmail.</para>
          <programlisting>
#!/bin/bash
# installs exim as another alternative to sendmail

/usr/sbin/alternatives --install /usr/sbin/sendmail mta \
                                 /usr/local/exim/bin/exim 90 \
  --slave /usr/bin/mailq mta-mailq /usr/local/exim/bin/exim \
  --slave /usr/bin/newaliases mta-newaliases /usr/bin/newaliases.sendmail \
  --slave /usr/bin/rmail mta-rmail /usr/local/exim/bin/exim \
  --slave /usr/share/man/man1/mailq.1.gz mta-mailqman \
          /usr/share/man/man1/mailq.sendmail.1.gz \
  --slave /usr/share/man/man1/newaliases.1.gz mta-newaliasesman \
          /usr/share/man/man1/newaliases.sendmail.1.gz \
  --slave /usr/share/man/man5/aliases.5.gz mta-aliasesman \
          /usr/share/man/man5/aliases.sendmail.5.gz \
  --initscript exim
</programlisting>
        </simplesect>
        <simplesect id="set_mta_sh">
          <title>set-mta.sh</title>
          <programlisting>
#!/bin/bash
# set MTA (Mail Transport Agent) to sendmail or exim

case "${1}" in
  ls )
    /usr/sbin/alternatives --display mta
    exit 0
    ;;
  exim )
    /sbin/service sendmail stop
    /usr/sbin/alternatives --set mta /usr/local/exim/bin/exim
    /sbin/service exim start
    /sbin/chkconfig sendmail off
    /sbin/chkconfig --level 2345 exim on
    exit 0
    ;;
  sendmail )
    /sbin/service exim stop
    /usr/sbin/alternatives --set mta /usr/sbin/sendmail.sendmail
    /sbin/service sendmail start
    /sbin/chkconfig exim off
    /sbin/chkconfig --level 2345 sendmail on
    exit 0
    ;;
  * )
     echo "Usage: ${0} [ ls | exim | sendmail ]"
     exit 0
     ;;
esac
</programlisting>
        </simplesect>
      </section>
      <section id="testing">
        <title>Testing Exim</title>
        <itemizedlist>
          <listitem>
            <para>Checking that the config file is OK:
<screen>
<prompt>bash$</prompt> <command>/usr/local/exim/bin/exim -bV</command>
<prompt>bash$</prompt> <command>/usr/local/exim/bin/exim -bV -C /usr/local/exim/exim_1.conf</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Checking some addresses:
<screen>
<prompt>bash$</prompt> <command>/usr/local/exim/bin/exim -bt dasho@dns3.inima.al</command>
<prompt>bash$</prompt> <command>/usr/local/exim/bin/exim -bt dhoxha@inima.al</command>
<prompt>bash$</prompt> <command>/usr/local/exim/bin/exim -bt dashohoxha@yahoo.com</command>
</screen></para>
          </listitem>
          <listitem>
            <para>Check sending an e-mail:
<screen>
<prompt>bash#</prompt> <command>/usr/local/exim/bin/exim -v dhoxha@inima.al</command>
From: dasho@dns3.inima.al
To: dhoxha@inima.al
Subject: Testing exim

Testing exim
.
</screen></para>
          </listitem>
          <listitem>
            <para>How to test with full debug output using a specific config file:
<screen>
<prompt>bash#</prompt> <command>/usr/local/exim/bin/exim -C /usr/local/exim/exim_1.conf -d -bt dhoxha@inima.al</command>
</screen></para>
          </listitem>
          <listitem>
            <para>How to test as if coming from a specified ip address:
<screen>
<prompt>bash#</prompt> <command>/usr/local/exim/bin/exim -bh 192.168.10.2</command>
HELO inima.al
MAIL FROM: dasho@dns3.inima.al
RCPT TO: dhoxha@inima.al
DATA
Subject: something
your message here
.
</screen></para>
          </listitem>
        </itemizedlist>
      </section>
      <section id="references">
        <title>References and Related Links</title>
        <para>Related links:</para>
        <itemizedlist>
          <listitem>
            <para>
              <ulink url="http://www.flatmtn.com/computer/Linux-Exim4.html"/>
            </para>
          </listitem>
          <listitem>
            <para>
              <ulink url="http://192.168.251.195/docs/exim-html-4.40/doc/html/"/>
            </para>
          </listitem>
          <listitem>
            <para>
              <ulink url="http://192.168.251.195/docs/exim-pdf-4.40/doc/"/>
            </para>
          </listitem>
          <listitem>
            <para>
              <ulink url="http://www.exim.org/exim-html-4.40/doc/html/spec_toc.html"/>
            </para>
          </listitem>
          <listitem>
            <para>
              <ulink url="http://www.exim.org/exim-html-4.40/doc/html/filter_toc.html"/>
            </para>
          </listitem>
        </itemizedlist>
      </section>
    </section>
    <section id="jabberd">
      <title>Jabber - Instant Message Service</title>
      <orderedlist continuation="restarts" inheritnum="ignore">
        <listitem>
          <para>Download and unpack:
<screen>
<prompt>bash#</prompt> <command>mv labberd-2.0s2.tar.gz /usr/local/</command>
<prompt>bash#</prompt> <command>cd /usr/local/</command>
<prompt>bash#</prompt> <command>tar xfz jabberd-2.0s2.tar.gz</command>
<prompt>bash#</prompt> <command>cd jabberd-2.0s2/</command>
</screen></para>
        </listitem>
        <listitem>
          <para>Make sure that these developmnet packages are installed: krb5-devel, openssl-devel, mysql-devel
<screen>
<prompt>bash#</prompt> <command>rpm -q openssl-devel</command>
<prompt>bash#</prompt> <command>rpm -Uhv openssl-devel-0.9.7a-2.i386.rpm</command>
</screen></para>
        </listitem>
        <listitem>
          <para>Configure, make and install:
<screen>
<prompt>bash#</prompt> <command>export CFLAGS=-I/usr/kerberos/include</command>
<prompt>bash#</prompt> <command>./configure --prefix=/usr/local/jabberd --enable-debug</command>
<prompt>bash#</prompt> <command>make</command>
<prompt>bash#</prompt> <command>make check</command>
<prompt>bash#</prompt> <command>make install</command>
</screen></para>
        </listitem>
        <listitem>
          <para>Make some other system configurations:
<screen>
<prompt>bash#</prompt> <command>mysql -p -u dasho &lt; tools/db-setup.mysql</command>
<prompt>bash#</prompt> <command>/usr/sbin/groupadd jabber</command>
<prompt>bash#</prompt> <command>/usr/sbin/useradd -g jabber jabber</command>
<prompt>bash#</prompt> <command>mkdir -p /usr/local/jabberd/var/jabberd/log</command>
<prompt>bash#</prompt> <command>mkdir /usr/local/jabberd/var/jabberd/pid</command>
<prompt>bash#</prompt> <command>chown -R jabber:jabber /usr/local/jabberd/var/jabberd</command>
</screen></para>
        </listitem>
        <listitem>
          <para>Modify jabberd configuration files:
<screen><prompt>bash#</prompt> <command>vi /usr/local/jabberd/etc/jabberd/c2s.xml</command></screen><programlisting>
  &lt;router&gt;
    &lt; !-- IP/port the router is waiting for connections on -- &gt;
    &lt;ip&gt;192.168.251.195&lt;/ip&gt;            &lt; !-- default: 127.0.0.1 -- &gt;

  &lt;local&gt;
    &lt;id&gt;jabber.inima.al&lt;/id&gt;

    &lt;mysql&gt;
      &lt; !-- Database username and password -- &gt;
      &lt;user&gt;dasho&lt;/user&gt;
      &lt;pass&gt;dasho&lt;/pass&gt;

      &lt;basedn realm='inima'&gt;o=Inima.al&lt;/basedn&gt;
      &lt;basedn&gt;o=INIMA&lt;/basedn&gt;
</programlisting><screen><prompt>bash#</prompt> <command>vi /usr/local/jabberd/etc/jabberd/c2s.xml</command></screen><programlisting>
&lt;sm&gt;
  &lt;id&gt;jabber.inima.al&lt;/id&gt;

  &lt;router&gt;
    &lt; !-- IP/port the router is waiting for connections on -- &gt;
    &lt;ip&gt;192.168.251.195&lt;/ip&gt;            &lt; !-- default: 127.0.0.1 -- &gt;

  &lt;mysql&gt;
      &lt; !-- Database username and password -- &gt;
      &lt;user&gt;dasho&lt;/user&gt;
      &lt;pass&gt;dasho&lt;/pass&gt;
</programlisting></para>
        </listitem>
      </orderedlist>
      <para>References:
<orderedlist continuation="restarts" inheritnum="ignore"><listitem><para><ulink url="http://www.jabberdoc.org/quickstart.html"/></para></listitem></orderedlist></para>
    </section>
  </chapter>
  <chapter id="publication">
    <title>Documentation and Publication</title>
    <para/>
    <section id="phpwiki">
      <title>PHPWiki</title>
      <para/>
    </section>
    <section id="docbookwiki">
      <title>DocBook Wiki</title>
      <para/>
    </section>
    <section id="plone">
      <title>Plone CMS</title>
      <orderedlist numeration="arabic">
        <listitem>
          <para>Download <ulink url="http://www.python.org/2.3.5/">Python-2.3.5</ulink> , <ulink url="http://www.zope.org/Products/Zope/2.8.1">Zope-2.8.1</ulink> and <ulink url="http://plone.org/products/plone">Plone-2.1</ulink> : 
      <screen><prompt>bash#</prompt> <command>cd /usr/local/tgz/</command>
<prompt>bash#</prompt> <command>wget http://www.python.org/ftp/python/2.3.5/Python-2.3.5.tgz</command>
<prompt>bash#</prompt> <command>wget http://www.zope.org/Products/Zope/2.8.1/Zope-2.8.1-final.tgz</command></screen></para>
        </listitem>
        <listitem>
          <para>Install Python: 
      <screen><prompt>bash#</prompt> <command>cd /usr/local/</command>
<prompt>bash#</prompt> <command>mkdir -p scr/</command>
<prompt>bash#</prompt> <command>cd src/</command>
<prompt>bash#</prompt> <command>tar xfz ../tgz/</command>
<prompt>bash#</prompt> <command>cd Python-2.3.5/</command>
<prompt>bash#</prompt> <command>vi README</command></screen><screen><prompt>bash#</prompt> <command>./configure</command>
<prompt>bash#</prompt> <command>make</command>
<prompt>bash#</prompt> <command>make altinstall</command></screen>
The last command will install python as an alternative in <filename>/usr/local/</filename> , without touching the existing version of python which is already installed.     </para>
        </listitem>
        <listitem>
          <para>Install the Zope framework: 
      <screen><prompt>bash#</prompt> <command>cd /usr/local/src/</command>
<prompt>bash#</prompt> <command>tar xfz ../tgz/Zope-2.8.1-final.tgz</command>
<prompt>bash#</prompt> <command>cd Zope-2.8.1-final</command></screen><screen><prompt>bash#</prompt> <command>./configure --prefix=/usr/local/zope/ --with-python=/usr/local/bin/python2.3</command>
<prompt>bash#</prompt> <command>make</command>
<prompt>bash#</prompt> <command>make install</command></screen></para>
        </listitem>
        <listitem>
          <para>Create a zope instance named <emphasis>inima</emphasis> : 
      <screen><prompt>bash#</prompt> <command>/usr/local/zope/bin/mkzopeinstance.py</command>
Please choose a directory in which you'd like to install
Zope "instance home" files such as database files, configuration
files, etc.
 
Directory: /var/www/html/tools/zope/inima
Please choose a username and password for the initial user.
These will be the credentials you use to initially manage
your new Zope instance.
 
Username: inima
Password:
Verify password:
<prompt>bash#</prompt> <command>chown dasho.dasho -R /var/www/html/tools/zope/inima/</command></screen></para>
        </listitem>
        <listitem>
          <para>In order to test this instance of zope, start it: 
      <screen><prompt>bash$</prompt> <command>/var/www/html/tools/zope/inima/bin/zopectl start</command></screen>
and then open <ulink url="http://192.168.252.1:8080/"/> in browser. Try also <ulink url="http://192.168.252.1:8080/manage"/> , here you should login with the username and password used above. 
      <note><para>Zope is (among others) a web server on its own, which can run besides apache.</para></note><note><para>If there is a firewall, don't forget to open the port 8080.</para></note></para>
        </listitem>
        <listitem>
          <para>Install Plone by extracting it and copying its product folders in the <filename>Products/</filename> folder of the <emphasis>inima</emphasis> instance: 
      <screen><prompt>bash$</prompt> <command>cd /var/www/html/tools/zope/inima/</command>
<prompt>bash$</prompt> <command>tar xfz /usr/local/tgz/Plone-2.1.tar.gz</command>
<prompt>bash$</prompt> <command>mv Plone-2.1/* Products/</command>
<prompt>bash$</prompt> <command>rm -rf Plone-2.1/</command>
<prompt>bash$</prompt> <command>bin/zopectl restart</command></screen></para>
        </listitem>
        <listitem>
          <para>Add a Plone instance in Zope: login at <ulink url="http://localhost:8080/manage"/> , add <emphasis>Plone Site</emphasis> from the listbox at the top, and set the id as <emphasis>inima</emphasis> . Now the new Plone instance can be seen at <ulink url="http://localhost:8080/inima"/></para>
        </listitem>
      </orderedlist>
      <para>References: </para>
      <itemizedlist>
        <listitem>
          <para>
            <ulink url="http://plone.org/documentation/how-to/setup-from-source"/>
          </para>
        </listitem>
      </itemizedlist>
    </section>
  </chapter>
  <chapter id="protection">
    <title>Protection Tools</title>
    <para/>
    <section id="clamav">
      <title>ClamAV - Virus Protection</title>
      <para/>
    </section>
    <section id="spamassassin">
      <title>SpamAssassin</title>
      <para/>
    </section>
    <section id="mailscanner">
      <title>MailScanner - Protecting from e-mail viruses and spam</title>
      <para/>
    </section>
    <section id="tripwire">
      <title>Tripwire - Securing the server</title>
      <para/>
    </section>
  </chapter>
  <chapter id="netmonitor">
    <title>Network Monitoring</title>
    <para/>
    <section id="lg">
      <title>Looking Glasses</title>
      <para/>
      <section id="phplg">
        <title>PHP Looking Glass</title>
        <para/>
      </section>
    </section>
    <section id="rancid">
      <title>RANCID - Monitoring the Routers</title>
      <para/>
    </section>
    <section id="smokeping">
      <title>SmokePing</title>
      <para/>
    </section>
    <section id="cricket">
      <title>Cricket</title>
      <para/>
    </section>
    <section id="cacti">
      <title>Cacti</title>
      <para/>
    </section>
    <section id="nagios">
      <title>Nagios</title>
      <para/>
    </section>
    <section id="rrdtool">
      <title>RRDTool</title>
      <para/>
    </section>
  </chapter>
  <chapter id="managment">
    <title>Managment and Coordination</title>
    <para/>
    <section id="zentrack">
      <title>zenTrack</title>
      <para/>
    </section>
    <section id="rt">
      <title>Request Tracker</title>
      <para/>
    </section>
    <section id="f2w">
      <title>f2w</title>
      <para/>
    </section>
    <section id="viewcvs">
      <title>ViewCVS</title>
      <para/>
    </section>
    <section id="cvsweb">
      <title>cvsweb</title>
      <para/>
    </section>
  </chapter>
  <chapter id="remoteadmin">
    <title>Remote Admin Tools</title>
    <para/>
    <section id="phpmyadmin">
      <title>phpMyAdmin - Administrate MYSQL Servers From the Web</title>
      <para/>
    </section>
    <section id="webmin">
      <title>Webmin</title>
      <para/>
    </section>
  </chapter>
  <chapter id="misc">
    <title>Misc Notes</title>
    <para/>
    <section id="wget">
      <title>Using wget to download a whole website</title>
      <screen>
<prompt>bash#</prompt> <command>wget \
    --recursive \
    --no-clobber \
    --page-requisites \
    --html-extension \
    --convert-links \
    --restrict-file-names=windows \
    --domains website.org
    www.website.org         
</command>
</screen>
      <para>This command:
<itemizedlist><listitem><para>downloads a whole website (--recursive)</para></listitem><listitem><para>the website www.website.org</para></listitem><listitem><para>without getting the links outside of this domain (--domains website.org)</para></listitem><listitem><para>getting all the elements that compose the page (--page-requisites) such as images, css, etc.</para></listitem><listitem><para>saving the files with an extension <emphasis>.html</emphasis> (--html-extension)</para></listitem><listitem><para>converting the links so that they work locally, offline (--convert-links)</para></listitem><listitem><para>and modifying file names so that they work in windows (--restrict-file-names=windows)</para></listitem></itemizedlist></para>
      <para>For more information about the options, their meaning and their usage, see:
<screen>
<prompt>bash$</prompt> <command>wget --help | more</command>
<prompt>bash$</prompt> <command>man wget</command>
<prompt>bash$</prompt> <command>info wget</command>
</screen></para>
    </section>
    <section id="find-in-which-package">
      <title>Finding in Which Package There is a File</title>
      <para>Sometimes we have to know in which package is a certain program or library that we need, so that we can install this it. This can be done like this:
<screen>
<prompt>bash$</prompt> <command>cd RedHat/RPMS/</command>
<prompt>bash$</prompt> <command>ls *cern* | xargs rpm --query --list --filesbypkg --package | grep 'libswigpl'</command>
</screen>
In the example above, <filename>RedHat/RPMS/</filename> is the folder that contains the rpm packages. The second command gets a list of all the packages that contain the word 'cern', then runs the command <command>rpm -qlp</command> on them in order to query their information and get a list of the files that they contain, then this list is filtered thrugh <command>grep</command> so that we get only the results that we are interested in. The option --filesbypkg is needed so that togather with the resulting files we get also the packages to which they belong.</para>
    </section>
    <section id="diff-and-patch">
      <title>Find Differences And Patch Different Versions</title>
      <para>Explain the story here.</para>
      <screen>
<prompt>bash$</prompt> <command>diff -rubBdN ilar_1 ilar_2 &gt; ilar.diff</command>
<prompt>bash$</prompt> <command>diff -qrubBN ilar_1 ilar_2 &gt; ilar_l.diff</command>
<prompt>bash$</prompt> <command>patch -p1 -uERl --dry-run -i ../ilar.diff</command>
<prompt>bash$</prompt> <command>patch -p1 -uERl -i ../ilar.diff</command>
</screen>
      <para>Explain here the different options that are used.</para>
    </section>
    <section id="corrupted-rpm">
      <title>Corrupted RPM Database</title>
      <para>Sometimes, may happen that the RPM database is corrupted for some reason, and the <command>rpm</command> command doesn't work anymore, outputing error messages like this: 
    <screen>rpmdb: Program version 4.2 doesn't match environment version
error: db4 error(22) from dbenv-&gt;open: Invalid argument
error: cannot open Packages index using db3 - Invalid argument (22)</screen></para>
      <para>In this case, the solution is to remove the RPM database and to rebuild it: 
    <screen><prompt>bash#</prompt> <command>rm -f /var/lib/rpm/__*</command>
<prompt>bash#</prompt> <command>rpm --rebuild</command></screen></para>
      <note>
        <para>In case that the last command does not work, try this one:

  <screen><prompt>bash#</prompt> <command>LD_ASSUME_KERNEL=2.4.18 rpm --rebuild</command></screen></para>
      </note>
    </section>
    <section id="bigtar">
      <title>Save a Big Archive in Multiple Floppies</title>
      <para>If there is a big file which cannot be saved in a floppy, or if a tar archive is too big to be saved in a single floppy, then this command can be used: 
    <screen><prompt>bash$</prompt> <command>tar -c -M -f /dev/fd0 LCG/LCG-2-UserGuide.pdf rhel-selg-en.pdf</command></screen></para>
      <para><emphasis>-M</emphasis> is <emphasis>--multi-volume</emphasis> and it tells <command>tar</command> to save the resulting archive file in several floppies. It will prompt fore replacing floppies, when necessary. </para>
      <para>To extract, use: </para>
      <screen><prompt>bash$</prompt> <command>tar -x -M -f /dev/fd0</command></screen>
    </section>
    <section id="cvs-svn">
      <title>Working With Two Repositories (CVS+SVN)</title>
      <para>When I work in a project that is stored in a public/remote CVS repository (such as SourceForge), it is not very practical to make commits and updates very frequently. I want to make changes and test them locally before commiting them to the public CVS repository. In this case, I use a second versioning system locally, to make things easier. </para>
      <para>I do it like this: </para>
      <orderedlist numeration="arabic">
        <listitem>
          <para>Create a local Subversion repository: 
      <screen><prompt>bash#</prompt> <command>svnadmin create /data/svn/docbookwiki</command>
<prompt>bash#</prompt> <command>chown -R dasho.dasho /data/svn/docbookwiki/</command></screen></para>
        </listitem>
        <listitem>
          <para>Ignore the <filename>CVS</filename> directories when working with SVN. Edit <filename>~/.subversion/config</filename> and modify these lines: 
      <programlisting>[miscellany]
global-ignores = CVS</programlisting></para>
        </listitem>
        <listitem>
          <para>Ignore the <filename>.svn</filename> directories when working with CVS. Edit <filename>~./cvsignore</filename> and add this line: 
      <programlisting>.svn</programlisting></para>
        </listitem>
        <listitem>
          <para>Checkout from SF the project: 
      <screen><prompt>bash$</prompt> <command>cvs -z3 -d :ext:dashohoxha@cvs.sf.net:/cvsroot/doc-book checkout book</command></screen></para>
        </listitem>
        <listitem>
          <para>Import it in the SVN repository (CVS directories will be ignored): 
      <screen><prompt>bash$</prompt> <command>svn import book/ file:///data/svn/docbookwiki/trunk</command></screen></para>
        </listitem>
        <listitem>
          <para>Checkout a copy from the SVN repository: 
      <screen><prompt>bash$</prompt> <command>mv book book_1</command>
<prompt>bash$</prompt> <command>svn checkout file:///data/svn/docbookwiki/trunk book/</command></screen></para>
        </listitem>
        <listitem>
          <para>Merge  the CVS directories in it, which keep the connection with the CVS repository: 
      <screen><prompt>bash$</prompt> <command>cp -r book_1/* book/</command></screen>
Now we can synchronize with both the CVS and the SVN repository: 
      <screen><prompt>bash$</prompt> <command>svn update book/</command>
<prompt>bash$</prompt> <command>cd book/</command>
<prompt>bash$</prompt> <command>cvs -z3 -q update -Pd</command></screen></para>
        </listitem>
        <listitem>
          <para>Create a test copy of the project  and install it: 
      <screen><prompt>bash$</prompt> <command>cd ..</command>
<prompt>bash$</prompt> <command>mkdir -p test/</command>
<prompt>bash$</prompt> <command>svn checkout file:///data/svn/docbookwiki/trunk test/book/</command>
<prompt>bash$</prompt> <command>cd test/book/</command>
<prompt>bash$</prompt> <command>./install.sh</command></screen></para>
        </listitem>
      </orderedlist>
    </section>
    <section id="get-screenshot">
      <title>Getting a Screenshot in Linux</title>
      <para>A screenshot get be taken by pressing the key "Print Screen" in the keyboard. </para>
      <para>To get a screenshot of just a single window: </para>
      <orderedlist numeration="arabic">
        <listitem>
          <para>Run <command>xwininfo</command> and click the window that you want to capture: 
      <screen><prompt>bash$</prompt> <command>xwininfo</command>
xwininfo: Please select the window about which you
          would like information by clicking the
          mouse in that window.
xwininfo: Window id: 0x140001d "making movies.sxw - OpenOffice.org 1.1.0 "
  Absolute upper-left X:  4
  Absolute upper-left Y:  18
. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .</screen></para>
        </listitem>
        <listitem>
          <para>Use the <command>import</command> command to capture the window (using the window id from above): 
      <screen><prompt>bash$</prompt> <command>sleep 5; import -window 0x140001d window.miff</command></screen></para>
        </listitem>
        <listitem>
          <para>Use <command>display</command> to see the captured image: 
      <screen><prompt>bash$</prompt> <command>display window.miff</command></screen></para>
        </listitem>
        <listitem>
          <para>Use <command>convert</command> to convert it to another format: 
      <screen><prompt>bash$</prompt> <command>convert window.miff window.png</command></screen></para>
        </listitem>
      </orderedlist>
      <para>References: </para>
      <itemizedlist>
        <listitem>
          <para>
            <ulink url="http://www.linuxdevcenter.com/pub/a/linux/2004/03/04/screen_capture_movies.html"/>
          </para>
        </listitem>
      </itemizedlist>
    </section>
  </chapter>
</book>
